
#include "actor.h"


Actor::Actor( Entity* ent ) : m_entity( ent )
{
	// for reference counting system to prevent deleting our entity class
	Entity::Handle( m_entity )._acquire();
	
	Initialize();
}

Actor::~Actor()
{
	Entity::Handle( m_entity )._release();
}


void Actor::Initialize()
{
	printf( "Actor(%p)::Initialize\n", this );
	if( m_entity->Initialize.not_null() )
	{
		Handle( this ).push( C );
		m_entity->Initialize.push( C );
		sgs_ThisCall( C, 0, 0 );
	}
}

void Actor::Think()
{
	printf( "Actor(%p)::Think\n", this );
	if( m_entity->Think.not_null() )
	{
		Handle( this ).push( C );
		m_entity->Think.push( C );
		sgs_ThisCall( C, 0, 0 );
	}
}


void Actor::SetModel( const sgsString& model )
{
	printf( "Actor(%p)::SetModel: %s\n", this, model.c_str() );
}

void Actor::SetPosition( const Vector3D& position )
{
	printf( "Actor(%p)::SetPosition: %g;%g;%g\n", this, position.x, position.y, position.z );
}

void Actor::SetVelocity( const Vector3D& velocity )
{
	printf( "Actor(%p)::SetVelocity: %g;%g;%g\n", this, velocity.x, velocity.y, velocity.z );
}

