
#pragma once
#include "common.h"
#include "entity.h"


class Actor
{
public:
	
	typedef sgsHandle< Actor > Handle;
	
	Actor( Entity* ent );
	~Actor();
	
	SGS_OBJECT;
	
	SGS_METHOD void Initialize();
	SGS_METHOD void Think();
	
	SGS_METHOD void SetModel( const sgsString& model );
	SGS_METHOD void SetPosition( const Vector3D& position );
	SGS_METHOD void SetVelocity( const Vector3D& velocity );
	
	SGS_METHOD void SetIndex( int i ){ /* ... */ }
	SGS_METHOD int GetIndex(){ return 0; }
	
	SGS_IFUNC(GCMARK) int sgs_gcmark( SGS_CTX, sgs_VarObj* obj )
	{
		// for garbage collector to prevent it from deleting our entity class
		
		Actor* actor = (Actor*) obj->data;
		Entity::Handle( actor->m_entity ).gcmark();
	}
	
	Entity* m_entity;
	
};


void sgs_register_actor( SGS_CTX );

